// simpleList.cc          
// version 1.0, Lg, July 8, 1995
// version 1.12, SM, July 2022


#include "simpleList.h"


void simpleList::append( simpleListEntry* p ) 
{ //             ======
    if ( _list_length++ == 0 ) _last = _first = p;
    else _last = _last->_next = p;
    p->_next = 0;
}


void simpleList::insert( simpleListEntry* p, simpleListEntry* atp )
{ //             ====== 
    _list_length++;
    if ( atp ) {
        simpleListEntry* temp = atp->_next; 
        atp->_next = p; 
        p->_next = temp;
    }
    else {
        p->_next = _first; 
        _first = p;
    }
    if ( p->_next == 0 ) _last = p;
}


simpleStringListEntry* simpleStringList::retrieve
//                                       ========
                                           ( const char* st, int* statusp ) {
    simpleStringListEntry* prev_entry = 0;
    simpleListEntry* cp = _first;
    simpleStringListEntry* curr_entry; 
    int i;
    char sti, cei; 
    while (cp) {
        curr_entry = (simpleStringListEntry*) cp;
        i=0;
        while ( (sti=st[i]) == (cei=curr_entry->strngp[i]) ) {
            if (sti) i++; 
            else { *statusp = exact_match; return curr_entry; }
        }
        if ( sti < cei ) { 
            if (sti) { *statusp = no_match; return prev_entry; }
            else { *statusp = is_prefix; return prev_entry; }
        }
        prev_entry = curr_entry; 
        cp = curr_entry->_next;
    }
    *statusp = no_match; return prev_entry;
}

simpleStringListEntry* simpleStringList::search
//                                       ======
                                           ( const char* st, int* statusp ) {
    simpleStringListEntry* prev_entry = 0;
    simpleListEntry* cp = _first;
    simpleStringListEntry* curr_entry; 
    int i;
    char sti, cei; 
    while (cp) {
        curr_entry = (simpleStringListEntry*) cp;
        i=0;
        while ( (sti=st[i]) == (cei=curr_entry->strngp[i]) ) {
            if (sti) i++; 
            else { *statusp = exact_match; return curr_entry; }
        }
        prev_entry = curr_entry; 
        cp = curr_entry->_next;
    }
    *statusp = no_match; return 0;
}
