// uti1a.cc
// version 1.1, Lg, August 1, 1996
//              history: version 1.0, Lg, July 19, 1995

#include <stdlib.h>
#include "uti1a.h"


void error( const char* filename, const char* msg, const char* s2 )
{ // =====
    cerr << "ERROR from \"" << filename << "\": " << msg << s2 << endl;
    exit(1);
}


void warning( const char* filename, const char* msg, const char* s2 )
{ // =======
    cerr << "ERROR from \"" << filename << "\": " << msg << s2 << endl;
}


void memory_error()
{ // ============
    cerr << "ERROR: not enough memory\n";
    exit(1);
}


void input_error( long int line, const char* msg, const char* s2 )
{ // ===========
    if ( line>=0 )
        cerr << "error on line " << line << ": ";
    cerr << msg << s2 << endl;
}


void input_warning( long int line, const char* msg, const char* s2 )
{ // =============
    if ( line>=0 )
        cerr << "warning on line " << line << ": ";
    cerr << msg << s2 << endl;
}


ostream& adjust_left( ostream& os )
{ //     ===========
    os.setf(ios::left, ios::adjustfield);
    return os;
}

ostream& adjust_right( ostream& os )
{ //     ============
    os.setf(ios::right, ios::adjustfield);
    return os;
}
